
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《JavaScript设计模式 张》整理 / 憋错料</title>

    <meta name="description" content="《JavaScript设计模式 张》整理 最近在研读另外一本关于设计模式的书&lt;JavaScript设计模式&gt;,这本书中描述了更多的设计模式. 一.创建型设计模式 包括简单工厂.工厂方法.抽象工厂.建造者.原型和单例模式. 1)简单工厂 又叫静态工厂方法,由一个工厂对象决定创建某一种产品对象类的实例. 两种实现方式,第一种是通过类实例化对象创建,第二种是创建一个新对象然后包装增强其属性和功能. demo代码. 2)工厂方法 通过对产品类的抽象使其创建业务主要负责用于创建多类产品的实例. 将工厂方法看作是一个实例化对象的工厂类. ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">《JavaScript设计模式 张》整理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>最近在研读另外一本关于设计模式的书《<a href="http://download.csdn.net/download/loneleaf1/9651753" rel="external nofollow noreferrer">JavaScript设计模式</a>》，这本书中描述了更多的设计模式。</p>
<h1>一、创建型设计模式</h1>
<p>包括简单工厂、工厂方法、抽象工厂、建造者、原型和单例模式。</p>
<p><strong>1）简单工厂</strong></p>
<p>又叫静态工厂方法，由一个工厂对象决定创建某一种产品对象类的实例。</p>
<p>两种实现方式，第一种是通过类实例化对象创建，第二种是创建一个新对象然后包装增强其属性和功能。</p>
<p><a href="http://codepen.io/strick/pen/JRZvkb" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>2）工厂方法</strong></p>
<p>通过对产品类的抽象使其创建业务主要负责用于创建多类产品的实例。</p>
<p>将工厂方法看作是一个实例化对象的工厂类。</p>
<p><a href="http://codepen.io/strick/pen/xEmRjp" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>3）抽象工厂</strong></p>
<p>通过对类的工厂抽象使其业务用于对产品类簇的创建，而不负责创建某一类产品的实例。</p>
<p>用它作为父类来创建一些子类。</p>
<p><a href="http://codepen.io/strick/pen/dparGR" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>4）建造者</strong></p>
<p>将一个复杂对象的构建层与其表示层相互分离，同样的构建过程可采用不同的表示。</p>
<p>它更关心的是创建这个对象的整个过程，甚至于创建对象的各个细节。</p>
<p><a href="http://codepen.io/strick/pen/YGBqkY" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>5）原型模式</strong></p>
<p>用原型实例指向创建对象的类，使用于创建新的对象的类共享原型对象的属性以及方法。</p>
<p>原型模式就是将可复用的、可共享的、耗时大的从基类中提取出来，放在其原型中，子类通过组合继承或寄生继承将方法和属性继承下来。</p>
<p><a href="http://codepen.io/strick/pen/jrJyoB" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>6）单例模式</strong></p>
<p>只允许实例化一次的对象类。有时我们也用一个对象来规划一个命名空间，井井有条的管理对象上的属性和方法。</p>
<p><a href="http://codepen.io/strick/pen/QKPWoE" rel="external nofollow noreferrer">demo代码</a>。</p>
<h1>二、结构型设计模式</h1>
<p><strong>1）外观模式</strong></p>
<p>为一组复杂的子系统接口提供一个更高级的统一接口，通过这个接口使得对子系统接口的访问更容易。</p>
<p>在JS中有时也会用于对底层结构兼容性做统一封装来简化用户使用。</p>
<p><a href="http://codepen.io/strick/pen/bwJOEE" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>2）适配器模式</strong></p>
<p>将一个类（对象）的接口（方法或属性）转化成另外一个接口，满足用户需求，使类（对象）之间接口的不兼容问题通过适配器解决。</p>
<p>适配异类框架，参数适配器，适配数据。</p>
<p><a href="http://codepen.io/strick/pen/BLEvLo" rel="external nofollow noreferrer">dmeo代码</a>。</p>
<p><strong>3）代理模式</strong></p>
<p>由于一个对象不能直接引用另一个对象，所以需要代理对象在这两个对象之间起到中介的作用。</p>
<p>站长统计、JSONP、代理模版。</p>
<p><strong>4）装饰者模式</strong></p>
<p>在不改变原对象的基础上，通过对其进行包装拓展（添加属性或方法）使原有对象能够满足更复杂的需求。</p>
<p><a href="http://codepen.io/strick/pen/VKOrBK" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>5）桥接模式</strong></p>
<p>在系统沿着多个纬度变化的同时，不增加其复杂度并已达到解耦。</p>
<p>提取共同点，事件与业务逻辑之间的桥梁，多元化对象。</p>
<p>将实现层（如元素的绑定事件）与抽象层（如修饰页面UI逻辑）解耦分离，使两部分可以独立变化。</p>
<p><a href="http://codepen.io/strick/pen/ZpdeGp" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>6）组合模式</strong></p>
<p>又称部分-整体模式，将对象组合成树形结构以表示“部分整体”的层次结构。</p>
<p>组合模式使得用户对单个对象和组合对象的使用具有一致性。</p>
<p>组合对象类通过继承同一个父类使其具有统一的方法，此时单体成员和组合成员行为表现就比较一致。</p>
<p><a href="http://codepen.io/strick/pen/dpBvXK" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>7）享元模式</strong></p>
<p>运用共享技术有效的支持大量的细粒度对象，避免对象间拥有相同内容造成多余的开销。</p>
<p>享元对象，享元动作。将共有的方法和数据提取，以提高页面效率。</p>
<p><a href="http://codepen.io/strick/pen/edwxQQ" rel="external nofollow noreferrer">demo代码</a>。</p>
<h1>三、行为型设计模式</h1>
<p><strong>1）模版方法模式</strong></p>
<p>父类中定义一组操作算法骨架，而将一些实现步骤延迟到子类中，使得子类可以不改变父类的结构算法的同时可重新定义算法中某些步骤的实现。</p>
<p>提示框归一化。</p>
<p><strong>2）观察者模式</strong></p>
<p>又被称作发布-订阅模式或消息机制，定义了一种依赖关系，解决了主体对象与观察者之间功能的耦合。</p>
<p>最大的作用是解决类或对象之间的耦合，解决两个相互依赖的对象，使其依赖于观察者的消息机制。</p>
<p><a href="http://codepen.io/strick/pen/PbYzaO" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>3）状态模式</strong></p>
<p>当一个对象的内部状态发生改变时，会导致其行为的改变，这看起来像是改变了对象。</p>
<p>状态模式既是解决程序中臃肿的分支判断语句问题，将每个分支转化为一种状态独立出来，方便每种状态的管理又不至于每次执行时遍历所有分支。</p>
<p><a href="http://codepen.io/strick/pen/oYNRBq" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>4）策略模式</strong></p>
<p>将定义的一组算法封装起来，使其相互之间可以替换。封装的算法具有一定的独立性，不会随客户端变化而变化。</p>
<p>策略模式使得算法脱离于模块逻辑而独立管理，使我们专心研发算法，而不必受模块逻辑所约束。</p>
<p>对分支语句的优化目前有3种，工厂方法、状态模式与策略模式。</p>
<p><strong>5）职责链模式</strong></p>
<p>解决请求的发送者与请求的接收者之间的耦合，通过职责链上的多个对象分解请求流程，实现请求在多个对象之间的传递，直到最后一个对象完成请求的处理。</p>
<p>分解需求，把每件事情分解成一个模块对象处理，需求分解成相互独立的部分，分工合作只做自己份内的事情，无关的事情传到下一个对象中，直到完成。</p>
<p>请求模块==》响应数据适配模块==》创建组件模块==》单元测试</p>
<p><strong>6）命令模式</strong></p>
<p>将创建模块的逻辑封装在一个对象里，这个对象提供一个参数化的请求接口，通过调用这个接口并传递参数实现对象内部的一些方法。</p>
<p>封装功能，提供简单而高效的API，解决命令的发起者和命令的执行者之间的耦合。</p>
<p><a href="http://codepen.io/strick/pen/wogrwb" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>7）访问者模式</strong></p>
<p>针对于对象结构中的元素，定义在不改变对象的前提下访问结构中元素的新方法。</p>
<p><strong>8）中介者模式</strong></p>
<p>通过中介者对象封装一系列对象之间的交互，使对象之间不再相互引用，降低他们之间的耦合。</p>
<p>观察者模式中的订阅者是相互的，而中介者模式订阅者是单向的，消息统一由中介者对象发布，所有的订阅者间接的被中介者管理。</p>
<p><strong>9）备忘录模式</strong></p>
<p>在不破坏对象的封装性的前提下，在对象之外捕获并保存该对象内部的状态以便日后对象使用，或者对象恢复恢复到以前的某个状态。</p>
<p>缓存数据，MVC中的M部分，很多时候都会缓存一些数据。</p>
<p><strong>10）迭代器模式</strong></p>
<p>在不暴露对象内部结构的同时，可以顺序的访问聚合对象内部的元素。</p>
<p>迭代器是优化循环语句的一种可行方案，使得程序清晰易读，解决了对象的使用者与对象内部结构之间的耦合。</p>
<p><a href="http://codepen.io/strick/pen/Lbxzxm" rel="external nofollow noreferrer">demo代码</a>。</p>
<h1>四、技巧型设计模式</h1>
<p><strong>1）委托模式</strong></p>
<p>多个对象接收并处理同一请求，他们将请求委托给另一个对象统一处理请求。</p>
<p>委托父元素、预言未来、数据分发。</p>
<p><a href="http://codepen.io/strick/pen/vyepdq" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>2）节流模式</strong></p>
<p>对重复的业务进行节流控制，执行最后一次操作并取消其他操作，以提高性能。</p>
<p>节流器、图片延迟加载、统计打包。</p>
<p><strong>3）简单模版模式</strong></p>
<p>通过格式化字符串拼凑出视图，避免创造视图时大量节点操作。</p>
<p>用正则匹配方式去格式化字符串性能要远高于拼接视图执行性能。</p>
<p>包括三部分：字符串模版库，格式化方法，字符串拼接操作。</p>
<p><a href="http://codepen.io/strick/pen/eBGPpL" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>4）惰性模式</strong></p>
<p>减少每次代码执行时的重复性分支判断，通过对对象重定义来屏蔽原对象中的分支判断。</p>
<p>惰性模式分为两种：第一种文件加载后立即执行对象方法来重定义，第二种是当第一次使用方法对象时来重定义。</p>
<p><a href="http://codepen.io/strick/pen/VmrOEv" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>5）参与者模式</strong></p>
<p>在特定的作用域中执行给定的函数，并将参数原封不动地传递。</p>
<p>参与者模式是两种技术的结晶，函数绑定和函数柯里化。</p>
<p><a href="http://codepen.io/strick/pen/MbOMJd" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>6）等待者模式</strong></p>
<p>通过对多个异步进程监听，来触发未来发生的动作。</p>
<p>等待者模式意在处理耗时比较长的操作，定时器操作、异步操作等。</p>
<p>在耗时操作内埋入监听者对象，在某个时刻改变监听者对象的状态，当所有监听者对象都是已完成的时候，执行完成回调，如果有一个是中断，就执行中断回调。</p>
<p><a href="http://codepen.io/strick/pen/rWYeqb" rel="external nofollow noreferrer">demo代码</a>。</p>
<h1>五、架构型设计模式</h1>
<p><strong>1）同步模块</strong></p>
<p>请求发出后，无论模块是否存在，立即执行后续的逻辑，实现模块开发中对模块的立即使用。</p>
<p><a href="http://codepen.io/strick/pen/WoXZEZ" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>2）异步模块</strong></p>
<p>AMD，请求发出后，继续其他业务逻辑，直到模块加载完成后执行后续的逻辑，实现模块开发中对模块加载完成后的引用。</p>
<p><strong>3）MVC</strong></p>
<p>用一种将业务逻辑、数据、视图分离的方式组织架构代码。</p>
<p>在视图层创建界面的时候，会用到模型层内的数据，使这两层耦合在一起。降低了视图创建的灵活性和复用性。</p>
<p><a href="http://codepen.io/strick/pen/ENbZvK" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>4）MVP</strong></p>
<p>View层不直接引用Model层的数据，而是通过Presenter层实现对Model层的数据访问。</p>
<p>所有层次的交互都发生在Presenter层中，解决View层和Model层之间的耦合。</p>
<p>但视图层还不够独立，创建怎样的视图由Presenter控制。</p>
<p><a href="http://codepen.io/strick/pen/bBYRbM" rel="external nofollow noreferrer">demo代码</a>。</p>
<p><strong>5）MVVM</strong></p>
<p>为View层量身订做一套ViewMode层，并在ViewMode中创建属性和方法，为View层绑定Model层的数据，并实现交互。</p>
<p>一个ViewMode可以对应多个View层或Model层，ViewMode中的代码变得高度复用。</p>
<p>View层的独立开发，可以使那些不懂JS的人，只需了解HTML内容并按照View层规范格式，创建视图，即可完成一个复杂的页面开发。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 19:12:07 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e9%ab%98%e5%ba%a6/" title="高度">高度</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.biecuoliao.com/tag/%e6%af%94%e8%be%83/" title="比较">比较</a>, <a href="https://www.biecuoliao.com/tag/%e5%8a%a8%e4%bd%9c/" title="动作">动作</a>, <a href="https://www.biecuoliao.com/tag/%e5%93%8d%e5%ba%94/" title="响应">响应</a>, <a href="https://www.biecuoliao.com/tag/%e8%a7%86%e5%9b%be/" title="视图">视图</a>, <a href="https://www.biecuoliao.com/tag/%e9%81%bf%e5%85%8d/" title="避免">避免</a>, <a href="https://www.biecuoliao.com/tag/%e9%9d%99%e6%80%81%e5%b7%a5%e5%8e%82%e6%96%b9%e6%b3%95/" title="静态工厂方法">静态工厂方法</a>, <a href="https://www.biecuoliao.com/tag/%e5%bc%82%e6%ad%a5%e6%93%8d%e4%bd%9c/" title="异步操作">异步操作</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>《JavaScript设计模式 张》整理的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/NMyqmMO.html" rel="bookmark">WPF笔记整理 - Bitmap和BitmapImage</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目中有图片处理的逻辑,因此要用到Bitmap.而WPF加载的一般都是BitmapImage.这里就需要将BitmapImage转成Bitmap 1. 图片的路径要用这样的,假设图片在project下的Images目录,文件名XXImage.png. pack://application:,,,/xxx;component/Images/XXImage.png 2. 代码: Bitmap bmp = null; var image = new BitmapImage(new Uri(this.X			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/j4Nm237.html" rel="bookmark">linux  命令  及学习进度综合整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				linux  命令  及学习进度综合整理 pwd 查看当前所在位置 cd  跳转到什么什么目录 ls  显示所有文件和目录 ls -l  显示目录详细信息 cd ..  返回上一级 vi  lnany.txt  创建一个文件 vi  .lnany.txt    创建一个隐藏文件 vim 是 vi 的升级版 功能更多 出现 -bash: vim: command not found 的解决办法 i. 那么如何安裝 vim 呢?输入rpm -qa|grep vim 命令, 如果 vim 已经正确安裝			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/VMGGPAM.html" rel="bookmark">夏令营讲课内容整理Day 0&period;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今年没有发纸质讲义是最气的.还好我留了点课件. 第一次用这个估计也不怎么会用,但尝试一下新事物总是好的. 前四天gty哥哥讲的内容和去年差不多,后三天zhn大佬讲的内容有点难,努力去理解吧. 毕竟知识还是需要消化的. 这里我只整理知识点,每天上午评测的题目我会单独处理. 嗯大概就是这样了. 写完后我就会考虑发到博客园里.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n3ZVbG3.html" rel="bookmark">linux基本命令整理（三）：进程和vim</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				linux基本命令整理(三) -----------进程和vim 一.进程 1.查看进程 ps:将某个时间点的程序运行的状况截取下来 a:所有的进程 x:后台进程 u:有效的使用者相关的进程(常用组合aux) -IA:也能观察系统所有的数据 axjf:连同部分的程序树状态 -I:今查看和自己bash相关的程序 top:动态的观察进程的变化 -d:后面接描述,就是整个页面刷新的时间:默认是5秒 -b:以批次的方式执行top -n:与-b搭配使用,意义是需要进行几次top的输出结果 如:top -b			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/N4pvOP0.html" rel="bookmark">检测和整理索引碎片</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				索引碎片的检测和整理 存储数据是为了查找数据,存储结构影响数据查找的性能.对无序数据进行查找,最快的查找算法是哈希查找:对有序数据进行查找,最快的查找算法是平衡树查找.在传统的关系型数据库中,聚集索引和非聚集索引都是平衡树(B-Tree)类型的存储结构,用于顺序存储数据,便于实现数据的快速查找.除了提升数据查找的性能之外,索引还能减少硬盘IO和内存消耗.通常情况下,硬盘IO是查找性能的瓶颈,由于索引是数据表的列的子集,这意味着,索引只存储部分列的数据,占用的硬盘空间比全部列少了很多,因此,数据库			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/VMGGQoM.html" rel="bookmark">新awk整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				总感觉上一篇awk的总结几乎是照着man翻译过来的,惨不忍睹 无意间在互联网上有找到了宝贵的资料 感觉整理的很好,想着照着这个来重新写下,对照新的man更新下吧,只是总是在改变的 一.awk简介二.awk工作流程三.awk程序结构四.awk基本语法 awk命令行模式 awk程序文件 awk标准选项五.awk内置变量 标准awk变量 awk特定变量(即专有变量)六.awk操作符 算数运算符 关系运算符 逻辑运算符 三元运算符 一元运算符 字符串连接操作符(即空格符) 数组成员操作符(in) 正则表			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/pMP8wnM.html" rel="bookmark">Linux运维（十）-2016-12-9整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				也有段时间没有整理面试题目了,这几天呢,完成了2场实习生和1场校招,十分郁闷,为什么金融运维一点都不关注技术,在乎我的学校成绩,我尼玛想说,学校那么水的课程能说明什么,跟技术有一丁丁点关系吗?我学业成绩不好,就能否定我的专业岗位基础不行吗?唉,劳资想说,你如果质疑我的能力,你就问我,劳资要是被你虐倒是我算我输,学艺不精我就服,看过去有球用. 这辈子职业生涯都不想进外包和IDC这两种类型的公司,就是TM打杂的,薪资还低,关键是不厚道,比如垃圾胜蓝.这回校招那家是我之前就提到的那家,大多数人对我是认			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/QM61OZ4.html" rel="bookmark">Web网站服务及知识整理（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Web网站服务及知识整理(二)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/gMWYym3.html" rel="bookmark">整理第三方类库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网络 AFNetworking:mattt大神的网络事件处理框架. XMPPFramework:XMPP,主要用于即时通讯. CocoaAsyncSocket:异步socket请求框架. Reachability:用来检查应用当前的网络连接状况,是苹果Reachability类的直接替代品,支持ARC,支持block,使用GCD方法来通知网络接口的变化. SocketRocket:WebSocket协议是一种网络协议,它的Web设计实现了浏览器与服务器的双向通讯.通过使用WebSockets,你			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/yMXLv8M.html" rel="bookmark">select、poll、epoll之间的区别总结&lbrack;整理&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				select,poll,epoll都是IO多路复用的机制.I/O多路复用就通过一种机制,可以监视多个描述符,一旦某个描述符就绪(一般是读就绪或者写就绪),能够通知程序进行相应的读写操作.但select,poll,epoll本质上都是同步I/O,因为他们都需要在读写事件就绪后自己负责进行读写,也就是说这个读写过程是阻塞的,而异步I/O则无需自己负责进行读写,异步I/O的实现会负责把数据从内核拷贝到用户空间.关于这三种IO多路复用的用法,前面三篇总结写的很清楚,并用服务器回射echo程序进行了测试.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgEKK3.html" rel="bookmark" class="title">hdu1024---Max Sum Plus Plus</a>
					<div>
						Max Sum Plus Plus Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYO9q0.html" rel="bookmark" class="title">java class 文件解析</a>
					<div>
						参考下面两个文章对一个class文件进行解析: http://docs.oracle.com/javase/specs/jvms/se7/html/jvms-4.html#jvms-4.4.6 htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mml8R14.html" rel="bookmark" class="title">webform组合查询和分页</a>
					<div>
						1.组合查询(1)数据访问类 //参数1:SQL语句 参数2:哈希表public List&lt;Users&gt; chas(string s,Hashtable has) { List&lt;Us ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGEqDQ3.html" rel="bookmark" class="title">操作像素</a>
					<div>
						图像的每一个像素用矩阵来表示,opencv用cv::Mat结构来操作图像. 用迭代器扫描图像 cv::MatIterator_&lt;cv::Vec3b&gt;it; for (;it!=itend; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RY2ojM.html" rel="bookmark" class="title">Method Calling in Perl</a>
					<div>
						This is notes from reading the &quot;object oriented perl programming&quot;. Elements of the @_ arra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5NzN3.html" rel="bookmark" class="title">shell中命令的执行流程</a>
					<div>
						在shell中,一个命令有3中写法: 1 可以直接写(Normal Command) 2 可以放在双引号中(&quot;Command&quot;) 3 可以放在单引号中('Comand') 这3中写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d99mn3.html" rel="bookmark" class="title">java异常处理Exception</a>
					<div>
						我看别人的面经中有一道题目就问到了Exception,即java的异常处理的,我以前也学了java的异常处理,但是我查了下,看了别人的博客关于写的exception异常处理,我发现,自己学的不牢固,只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kZljPM.html" rel="bookmark" class="title">PHP学习之中数组--创建数组【1】</a>
					<div>
						在PHP中数组的定义有三种写法,分别是: &lt;?php //第一种方式是用关键字 array来创建的 $username = array(&quot;demo1&quot;,&quot;demo2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pznXw0.html" rel="bookmark" class="title">Delete Volume 操作 - 每天5分钟玩转 OpenStack（57）</a>
					<div>
						今天讨论 cinder 如何删除 volume . 状态为 Available 的 volume 才能够被 delete.如果 volume 当前已经 attach 到 instance,需要先 de ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOPKO0.html" rel="bookmark" class="title">C&plus;&plus;类型转化小结</a>
					<div>
						之前面试就有被问过关于使用类型转换的问题,因为主要是做Windows驱动的开发,一直都是纯C语言+汇编,当时真的是只用过C语言的强制类型转换,C语言的强制类型转换(Type Cast)很简单,不管什么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBY6lZ4.html" rel="bookmark" class="title">关于产品的一些思考&mdash;&mdash;&lpar;四十&rpar;腾讯微信之修改备注和标签</a>
					<div>
						--------------------2014.07.26-------------------- 在使用微信(Android 5.3.1)版本的时候,由于联系人比较多,需要修改备注和标签,可是问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymaNaM.html" rel="bookmark" class="title">hiredis  aeStop仅在redis命令的回调函数中生效 分析</a>
					<div>
						hiredis 是 redis 的client端C语言 lib,  hiredis拥有同步和异步的API, 异步API的实现有多种方法,分别依赖libev, libevent, libuv, ae等等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l76XZM.html" rel="bookmark" class="title">java 类加载器体系结构</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBoa73.html" rel="bookmark" class="title">鼻梁斜歪、塌陷者，心眼不正身体不好</a>
					<div>
						鼻梁斜歪.塌陷者,心眼不正身体不好,猜疑心的他会令你活的很累.身体不健康的他,未来会让你伺候的非常辛苦 http://baozoumanhua.com/users/19761841/following ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQ18g0.html" rel="bookmark" class="title">javascript  快速排序方法</a>
					<div>
						&quot;快速排序&quot;的思想很简单,整个排序过程只需要三步: (1)在数据集之中,选择一个元素作为&quot;基准&quot;(pivot). (2)所有小于&quot;基准&quot;的元 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4N1W9w3.html" rel="bookmark" class="title">python 内置函数！</a>
					<div>
						chr 数字转换字母 r = chr(65)print(r) ord字母转换数字n = ord(&quot;A&quot;)print(n) random 函数 import random li =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JjrYD4.html" rel="bookmark" class="title">Zabbix 3&period;0 监控Web &lbrack;七&rsqb;</a>
					<div>
						Zabbix 3.0 监控Web [七] 2016年10月0日 zabbix 笔者QQ:381493251 博客地址:www.abcdocker.com 微信公众号:abcdocker Abcdock ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aGWwv4.html" rel="bookmark" class="title">python aes加解密</a>
					<div>
						python AES加密解密 python AES 双向对称加密解密 Python中进行Base64编码和解码 # encoding:utf-8 import base64 from Crypto.C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLr8ly3.html" rel="bookmark" class="title">大数据学习笔记6&amp;&num;183&semi;社会计算中的大数据&lpar;4&rpar;</a>
					<div>
						上一篇介绍了LifeSpec项目,这个项目是关于用户理解和用户画像的.这篇是社会计算部分的最后一篇,关于用户连接和图隐私. 用户连接与隐私保护 用户连接与隐私保护有很强的相关性. 上图中,左边有两个网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgELy3.html" rel="bookmark" class="title">Alpha版本测试报告</a>
					<div>
						一.引言 1.1 测试目的 (1)测试爱码室团队Alpha版本爬虫的功能性.效率性和可靠性. (2)解决更新测试出的Alpha版本爬虫的Bug. (3)统计数据进行记录,方便日后与Beta版本比对.  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.034 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
